package org.me.funcionario;

public class FuncionarioComissao extends Funcionario {
    private double vendaBruta, comissao;

    public FuncionarioComissao(double vendaBruta, double comissao, String nome, String sobrenome, String CPF) {
        super(nome, sobrenome, CPF);
        this.vendaBruta = vendaBruta;
        this.comissao = comissao;
    }
    
    public double getVendaBruta() {
        return vendaBruta;
    }

    public void setVendaBruta(double vendaBruta) {
        this.vendaBruta = vendaBruta < 0 ? 0 : vendaBruta;
    }

    public double getComissao() {
        return comissao;
    }

    public void setComissao(double comissao) {
        this.comissao = comissao > 0 & comissao < 1 ? comissao : 0;
    }
    
    @Override
    public double calculoSalario()
    {
        return vendaBruta * comissao;
    }
    
    @Override
    public String toString(){
        return String.format("%s"
                + "\nVenda Bruta: %.2f"
                + "\nComissão: %.2f\n",
                super.toString(),
                getVendaBruta(),
                getComissao());
    }
}
