package org.me.funcionario;

public class FuncionarioHorista extends Funcionario {
    private double salHora;
    private int horas;

    public FuncionarioHorista(double salHora, int horas, String nome, String sobrenome, String CPF) {
        super(nome, sobrenome, CPF);
        this.salHora = salHora;
        this.horas = horas;
    }
    
    public double getSalHora() {
        return salHora;
    }

    public void setSalHora(double salHora) {
        this.salHora = salHora < 0 ? 0 : salHora;
    }

    public int getHoras() {
        return horas;
    }

    public void setHoras(int horas) {
        this.horas = horas > 0 & horas <= 168 ? horas : 0;
    }
    
    @Override
    public double calculoSalario()
    {
        if(horas <= 40)
        {
            return salHora * horas;
        }
        else
        {
            return 40 * getSalHora() + (getHoras()-40) * getSalHora() * 1.5;
        }
    }

    @Override
    public String toString()
    {
        return String.format("%s"
                + "\nSalario Hora: %.2f"
                + "\nHoras: %d\n", 
                super.toString(),
                getSalHora(),
                getHoras());
    }
}
