package org.me.fornecedor;

import java.sql.*;
import java.util.*;

public class FornecedorConecta {
    private static final String URL = "jdbc:derby://localhost:1527/fornecedores",
                                USERNAME = "TRABALHO",
                                PASSWORD = "trabalho";
    
    private Connection connection = null;
    private PreparedStatement insereFornecedor = null,
                              selecionaFornecedor = null,
                              alteraFornecedor = null,
                              excluiFornecedor = null;
    
    public FornecedorConecta() throws ClassNotFoundException
    {
        try
        {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            open();
            insereFornecedor = connection.prepareStatement("INSERT INTO TRABALHO.TABFORNECEDOR" +
                    "(NOME, CNPJ, EMAIL, ENDERECO, CIDADE, ESTADO, TELEFONE)" +
                    "VALUES(?,?,?,?,?,?,?)");
            selecionaFornecedor = connection.prepareStatement("SELECT * FROM TRABALHO.TABFORNECEDOR WHERE NOME = ?");
            alteraFornecedor = connection.prepareStatement("UPDATE TRABALHO.TABFORNECEDOR SET "
                    + "NOME = ?, CNPJ = ?, EMAIL = ?, ENDERECO = ?, CIDADE = ?, ESTADO = ?, TELEFONE = ? "
                    + "WHERE ID = ?");
            excluiFornecedor = connection.prepareStatement("DELETE FROM TRABALHO.TABFORNECEDOR WHERE ID = ?");
        }
        catch (SQLException sqlE)
        {
            sqlE.printStackTrace();
            System.exit(1);
        }
    }
    public int adicionaFornecedor(String nome, 
         String cnpj, 
         String email, 
         String endereco, 
         String cidade, 
         String estado, 
         String telefone)
    {
          int result = 0;
          try
          {
              open();
              
              insereFornecedor.setString(1, nome);
              insereFornecedor.setString(2, cnpj);
              insereFornecedor.setString(3, email);
              insereFornecedor.setString(4, endereco);
              insereFornecedor.setString(5, cidade);
              insereFornecedor.setString(6, estado);
              insereFornecedor.setString(7, telefone);
              
              result = insereFornecedor.executeUpdate();
          }
          catch(SQLException sqlE)
          {
                sqlE.printStackTrace();
                close();
          }
          return result;
    }
    
    public int atualizaFornecedor(int id, String n, String c, String em, String e, String ci, String es, String t)
    {
        int res = 0;
        try{
            open();
            
            alteraFornecedor.setInt(8,id);
            alteraFornecedor.setString(1,n);
            alteraFornecedor.setString(2,c);
            alteraFornecedor.setString(3,em);
            alteraFornecedor.setString(4,e);
            alteraFornecedor.setString(5,ci);
            alteraFornecedor.setString(6,es);
            alteraFornecedor.setString(7,t);
            res = alteraFornecedor.executeUpdate();
        }
        catch(SQLException sqlE)
        {
            sqlE.printStackTrace();
            close();
        }
        
        return res;
    }
    
    public boolean deletaFornecedor(int ID)
    {
        boolean exclui = false;
        try{
            open();
            
            excluiFornecedor.clearParameters();
            excluiFornecedor.setInt(1, ID);
            exclui = true;
        }
        catch(SQLException sqlE)
        {
              sqlE.printStackTrace();
              close();
        }
        return exclui;
    }
    
    public List<Fornecedor> consultaFornecedor (String nome)
    {
        List<Fornecedor> res = null;
        ResultSet resSet = null;
        
        try{
            open();
            
            selecionaFornecedor.setString(1,nome);
            resSet = selecionaFornecedor.executeQuery();
            res = new ArrayList<Fornecedor>();
            while(resSet.next())
            {
                res.add(new Fornecedor(resSet.getInt("ID"),
                                       resSet.getString("Nome"),
                                       resSet.getString("Cnpj"),
                                       resSet.getString("Email"),
                                       resSet.getString("Endereco"),
                                       resSet.getString("Cidade"),
                                       resSet.getString("Estado"),
                                       resSet.getString("Telefone")));
                
            }
        }
        catch(SQLException sqlE)
        {
              sqlE.printStackTrace();
              close();
        }
        return res;
    }
    
    public void close()
    {
        try
        {
            connection.close();
        }
        catch(SQLException sqlE)
        {
            sqlE.printStackTrace();
        }
    }
    
    public void open()
    {
        try
        {
            connection = DriverManager.getConnection(URL, USERNAME, PASSWORD);
        }
        catch(SQLException sqlE)
        {
            sqlE.printStackTrace();
        }
    }
}
